package model.arbitre;

import javafx.scene.control.Cell;
import model.CellulesVivantes;
import model.plateau.Plateau;
import model.cellule.CellState;

public class ArbitreConwayStyle extends Arbitre{

	public ArbitreConwayStyle(Plateau plateau) {
		super(plateau);
	}

	@Override
	public CellState verifierChangementCellules(int x, int y) {
		if(verifierNaissance(x, y, getPlateau().getCellulesVivantes().clone())) {
			return CellState.BIRTH;
		}
		if(verifierMort(x, y, getPlateau().getCellulesVivantes())) {
			return CellState.DIE;
		}
		return getPlateau().getCell(x, y).isAlive() ? CellState.LIVE : CellState.DIE;
	}

	private boolean verifierNaissance(int x, int y, CellulesVivantes reference) {
		int cpt = getCompteurCell().compteNombreCellulesAutour(x, y, reference);
		if(cpt == 3 && !getPlateau().getCell(x, y).isAlive()) {
		 	return true;
		}
		return false;
	}

	private boolean verifierMort(int x, int y, CellulesVivantes reference) {
		int cpt = getCompteurCell().compteNombreCellulesAutour(x, y, reference);
		if(!(cpt == 2 || cpt == 3) && getPlateau().getCell(x, y).isAlive()) {
		 	return true;
		}
		return false;
	}
}
